/* CRS (Channelflow with options of Rotation and Stratification), 
   revised Channelflow-1.1.2 (John F. Gibson) code including rotation and stratification
   Copyright (C) 2007-2008 Hao Lu

   Engine Research Center
   1500 Engineering Dr. #1011
   Madison, WI 53706

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#include <stdio.h>

int SWAP(int i)
{
	union
	{
		int i;
		unsigned char b[4];
	} dat1, dat2;

	dat1.i = i;
	dat2.b[0] = dat1.b[3];
	dat2.b[1] = dat1.b[2];
	dat2.b[2] = dat1.b[1];
	dat2.b[3] = dat1.b[0];
	return dat2.i;
}

float SWAP(float f)
{
	union
	{
		float f;
		unsigned char b[4];
	} dat1, dat2;

	dat1.f = f;
	dat2.b[0] = dat1.b[3];
	dat2.b[1] = dat1.b[2];
	dat2.b[2] = dat1.b[1];
	dat2.b[3] = dat1.b[0];
	return dat2.f;
}

double SWAP(double df)
{
	union
	{
		double df;
		unsigned char b[8];
	} dat1, dat2;

	dat1.df = df;
	dat2.b[0] = dat1.b[7];
	dat2.b[1] = dat1.b[6];
	dat2.b[2] = dat1.b[5];
	dat2.b[3] = dat1.b[4];
	dat2.b[4] = dat1.b[3];
	dat2.b[5] = dat1.b[2];
	dat2.b[6] = dat1.b[1];
	dat2.b[7] = dat1.b[0];
	return dat2.df;
}

int IsBigEndian()
{
	short int word = 0x0001;
	char *byte = (char *) &word;
	return (byte[0] ? 0:1);
}

int BE(int i)
{
	if (IsBigEndian())
		return i;
	else
		return SWAP(i);
}

int LE(int i)
{
	if (IsBigEndian())
		return SWAP(i);
	else
		return i;
}

float BE(float f)
{
	if (IsBigEndian())
		return f;
	else
		return SWAP(f);
}

float LE(float f)
{
	if (IsBigEndian())
		return SWAP(f);
	else
		return f;
}

double BE(double df)
{
	if (IsBigEndian())
		return df;
	else
		return SWAP(df);
}

double LE(double df)
{
	if (IsBigEndian())
		return SWAP(df);
	else
		return df;
}

