reset

set termoption enhanced

set multiplot layout 2, 2

set autoscale
plot 'mean.$0' using 2:1 with lp title "{<u>}", \
     'mean.$0' using (-column(4)):1 with lp title "{<v>}"

set autoscale
plot 'mean.$0' using 6:1 with lp title "{<{/Symbol q}>}"
     
set logscale x
set xrange [0.1:300]
set yrange [-0.2:35]
plot 'U.$0' using 1:2 with lp title "{(U_{surf}-<u>)@^{+}_{top}}", \
     'U.$0' using 3:4 with lp title "{<u>@^{+}_{bottom}}", \
     'U.$0' using 5:6 with lp title "{<v>@^{+}_{top}}", \
     'U.$0' using 7:8 with lp title "{<v>@^{+}_{bottom}}", \
     'U.$0' using 9:10 with lp title "{(<{/Symbol q}>-{/Symbol q}_{top})@^{+}_{top}}", \
     'U.$0' using 11:12 with lp title "{({/Symbol q}_{bottom}-<{/Symbol q}>)@^{+}_{bottom}}", \
     x with lines lt rgb "#AAAAAA" notitle, \
     ((x<=10)? x:2.5*log(x)+5) title "{((y^{+}<=10)? y^{+}:2.5*ln(y^{+})+5)}"
unset logscale x

set autoscale
plot 'mean.$0' using 20:1 with lp title "Re_{{/Symbol l}}"
     
unset multiplot
